polybori::bounded_restricted_term< NaviType, DescendingProperty > Class Template Reference

`#include <pbori_routines_order.h>`

## Public Types

typedef NaviType | navigator
typedef DescendingProperty | descending_property
typedef bounded_restricted_term< navigator, descending_property > | self
typedef std::vector< navigator > | stack_type
typedef unsigned | size_type
typedef unsigned | idx_type

## Public Member Functions

| bounded_restricted_term ()
| bounded_restricted_term (navigator navi, size_type upperbound, idx_type max_idx)
size_type | operator* () const
const navigator & | next () const
stack_type::const_iterator | begin () const
stack_type::const_iterator | end () const
self & | operator++ ()
void | print () const
bool | operator== (const self &rhs) const
bool | operator!= (const self &rhs) const

## Public Attributes

is_same_type< descending_property, valid_tag > | descendingVariables

## Protected Member Functions

void | followThen ()
void | increment ()
bool | empty () const
navigator | top () const
bool | is_path_end ()
void | path_end ()
void | nextThen ()
bool | within_degree () const
bool | at_end () const

## Member Typedef Documentation

template<class NaviType , class DescendingProperty = valid_tag>

typedef DescendingProperty polybori::bounded_restricted_term< NaviType, DescendingProperty >::descending_property

template<class NaviType , class DescendingProperty = valid_tag>

typedef unsigned polybori::bounded_restricted_term< NaviType, DescendingProperty >::idx_type

template<class NaviType , class DescendingProperty = valid_tag>

typedef NaviType polybori::bounded_restricted_term< NaviType, DescendingProperty >::navigator

template<class NaviType , class DescendingProperty = valid_tag>

typedef bounded_restricted_term<navigator, descending_property> polybori::bounded_restricted_term< NaviType, DescendingProperty >::self

template<class NaviType , class DescendingProperty = valid_tag>

typedef unsigned polybori::bounded_restricted_term< NaviType, DescendingProperty >::size_type

template<class NaviType , class DescendingProperty = valid_tag>

typedef std::vector<navigator> polybori::bounded_restricted_term< NaviType, DescendingProperty >::stack_type

## Constructor & Destructor Documentation

template<class NaviType , class DescendingProperty = valid_tag>

polybori::bounded_restricted_term< NaviType, DescendingProperty >::bounded_restricted_term | ( |  | ) |

inline

template<class NaviType , class DescendingProperty = valid_tag>

polybori::bounded_restricted_term< NaviType, DescendingProperty >::bounded_restricted_term | ( | navigator | navi,
|  | size_type | upperbound,
|  | idx_type | max_idx
| ) |  |

inline

## Member Function Documentation

template<class NaviType , class DescendingProperty = valid_tag>

bool polybori::bounded_restricted_term< NaviType, DescendingProperty >::at_end | ( |  | ) | const

inline protected

template<class NaviType , class DescendingProperty = valid_tag>

stack_type::const_iterator polybori::bounded_restricted_term< NaviType, DescendingProperty >::begin | ( |  | ) | const

inline

template<class NaviType , class DescendingProperty = valid_tag>

bool polybori::bounded_restricted_term< NaviType, DescendingProperty >::empty | ( |  | ) | const

inline protected

template<class NaviType , class DescendingProperty = valid_tag>

stack_type::const_iterator polybori::bounded_restricted_term< NaviType, DescendingProperty >::end | ( |  | ) | const

inline

template<class NaviType , class DescendingProperty = valid_tag>

void polybori::bounded_restricted_term< NaviType, DescendingProperty >::followThen | ( |  | ) |

inline protected

template<class NaviType , class DescendingProperty = valid_tag>

void polybori::bounded_restricted_term< NaviType, DescendingProperty >::increment | ( |  | ) |

inline protected

References PBORI_ASSERT.

template<class NaviType , class DescendingProperty = valid_tag>

bool polybori::bounded_restricted_term< NaviType, DescendingProperty >::is_path_end | ( |  | ) |

inline protected

template<class NaviType , class DescendingProperty = valid_tag>

const navigator& polybori::bounded_restricted_term< NaviType, DescendingProperty >::next | ( |  | ) | const

inline

template<class NaviType , class DescendingProperty = valid_tag>

void polybori::bounded_restricted_term< NaviType, DescendingProperty >::nextThen | ( |  | ) |

inline protected

References PBORI_ASSERT.

template<class NaviType , class DescendingProperty = valid_tag>

bool polybori::bounded_restricted_term< NaviType, DescendingProperty >::operator!= | ( | const self & | rhs | ) | const

inline

template<class NaviType , class DescendingProperty = valid_tag>

size_type polybori::bounded_restricted_term< NaviType, DescendingProperty >::operator* | ( |  | ) | const

inline

template<class NaviType , class DescendingProperty = valid_tag>

self& polybori::bounded_restricted_term< NaviType, DescendingProperty >::operator++ | ( |  | ) |

inline

References PBORI_ASSERT.

template<class NaviType , class DescendingProperty = valid_tag>

bool polybori::bounded_restricted_term< NaviType, DescendingProperty >::operator== | ( | const self & | rhs | ) | const

inline

template<class NaviType , class DescendingProperty = valid_tag>

void polybori::bounded_restricted_term< NaviType, DescendingProperty >::path_end | ( |  | ) |

inline protected

template<class NaviType , class DescendingProperty = valid_tag>

void polybori::bounded_restricted_term< NaviType, DescendingProperty >::print | ( |  | ) | const

inline

template<class NaviType , class DescendingProperty = valid_tag>

navigator polybori::bounded_restricted_term< NaviType, DescendingProperty >::top | ( |  | ) | const

inline protected

template<class NaviType , class DescendingProperty = valid_tag>

bool polybori::bounded_restricted_term< NaviType, DescendingProperty >::within_degree | ( |  | ) | const

inline protected

## Member Data Documentation

template<class NaviType , class DescendingProperty = valid_tag>

is_same_type<descending_property, valid_tag> polybori::bounded_restricted_term< NaviType, DescendingProperty >::descendingVariables

The documentation for this class was generated from the following file:

- pbori_routines_order.h